/*
 * power_common.h
 *
 * common define for power module
 *
 * Copyright (c) 2020-2020 Huawei Technologies Co., Ltd.
 *
 * This software is licensed under the terms of the GNU General Public
 * License version 2, as published by the Free Software Foundation, and
 * may be copied, distributed, and modified under those terms.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 */

#ifndef _POWER_COMMON_H_
#define _POWER_COMMON_H_

#define POWER_BYTE_LEN                      1
#define POWER_WORD_LEN                      2
#define POWER_DWORD_LEN                     4

#define POWER_HALF                          2
#define POWER_PERCENT                       100

#define POWER_BASE_OCT                      8
#define POWER_BASE_DEC                      10
#define POWER_BASE_HEX                      16
#define THOUSAND_UNIT                       1000
#define INVALID_BATT_LOW_TEMP               (-40)
#define INVALID_BATT_HIGH_TEMP              80

#define MVOLT_PER_VOLT                      1000
#define MWATT_PER_WATT                      1000

#endif /* _POWER_COMMON_H_ */
